/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.common.part;

import java.util.Date;

import jp.mosp.common.part.BasePart;
import jp.mosp.common.part.PartInfo;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.workflow.dao.CtOvertimeRequestDao;
import jp.mosp.workflow.dto.CtOvertimeRequestDto;

/**
 * 残業申請に関するPartクラス
 * @author yoshida
 *	@version	0.0.1
 */
public class OverTimePart extends BasePart {
	
	/**
	 * コンストラクタ
	 */
	public OverTimePart() {
		super();
	}
	
	/**
	 * コンストラクタ
	 * @param partInfo Partを利用する際に必要な情報
	 */
	public OverTimePart(PartInfo partInfo) {
		super(partInfo);
	}
	

	/**
	 * CtOvertimeRequestDaoインスタンス
	 */
	private CtOvertimeRequestDao	overtimeRequestDao;
	

	/**
	 * 残業申請テーブルDAOの取得
	 * @return	初期化済みCtOvertimeRequestDaoインスタンス
	 * @throws Exception	例外処理が発生した場合
	 */
	public CtOvertimeRequestDao getCtOvertimeRequestDao() throws Exception {
		if (VariousUtil.isNull(overtimeRequestDao)) {
			overtimeRequestDao = (CtOvertimeRequestDao)getPreparedDao(CtOvertimeRequestDao.class.getCanonicalName());
		}
		return overtimeRequestDao;
	}
	
	/**
	 * 残業申請情報取得
	 * @param voucher		対象伝票番号
	 * @return	残業申請情報DTO
	 * @throws Exception	例外処理が発生した場合
	 */
	public CtOvertimeRequestDto getOverTimeRequest(int voucher) throws Exception {
		return getCtOvertimeRequestDao().findForKey(voucher);
	}
	
	/**
	 * 対象年月日残業申請情報取得
	 * @param kCode				対象社員コード
	 * @param targetDate		対象年月日
	 * @return	残業申請情報DTO
	 * @throws Exception	例外処理が発生した場合
	 */
	public CtOvertimeRequestDto getOverTimeRequest(String kCode, Date targetDate) throws Exception {
		return getCtOvertimeRequestDao().findForWorkDate(kCode, targetDate);
	}
	
	/**
	 * 残業申請判断
	 * @param kCode				対象社員コード
	 * @param targetDate		対象年月日
	 * @return	残業申請がある場合true、そうでない場合false
	 * @throws Exception	例外処理が発生した場合
	 */
	public boolean isOverTimeRequest(String kCode, Date targetDate) throws Exception {
		if (VariousUtil.isNotNull(getOverTimeRequest(kCode, targetDate))) {
			return true;
		}
		return false;
	}
	
}
